Index: palm/trunk/SOURCE/bulk_cloud_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 4541)
+++ palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 4542)
@@ -1704,11 +1659,10 @@
                 !DIR$ IVDEP
                 DO  k = nzb+1, nzt
-                   nc_p(k,j,i) = nc(k,j,i) + ( dt_3d * ( sbt * tend(k,j,i) +   &
-                                                      tsc(3) * tnc_m(k,j,i) )  &
-                                                    - tsc(5) * rdf_sc(k) *     &
-                                                               nc(k,j,i)       &
-                                             )                                 &
-                                   * MERGE( 1.0_wp, 0.0_wp,                    &
-                                             BTEST( wall_flags_total_0(k,j,i), 0 )   &
+                   nc_p(k,j,i) = nc(k,j,i) + ( dt_3d * ( sbt * tend(k,j,i) +                       &
+                                                      tsc(3) * tnc_m(k,j,i) )                      &
+                                                    - tsc(5) * rdf_sc(k) *                         &
+                                                               nc(k,j,i)                           &
+                                             )                                                     &
+                                   * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 )  &
                                           )
                    IF ( nc_p(k,j,i) < 0.0_wp )  nc_p(k,j,i) = 0.0_wp
@@ -1733,6 +1687,5 @@
                    DO  j = nys, nyn
                       DO  k = nzb+1, nzt
-                         tnc_m(k,j,i) =  -9.5625_wp * tend(k,j,i)             &
-                                         + 5.3125_wp * tnc_m(k,j,i)
+                         tnc_m(k,j,i) =  -9.5625_wp * tend(k,j,i) + 5.3125_wp * tnc_m(k,j,i)
                       ENDDO
                    ENDDO
@@ -1746,6 +1699,6 @@
 
 !
-!--    If required, calculate prognostic equations for ice crystal content
-!--    and ice crystal concentration
+!--    If required, calculate prognostic equations for ice crystal content and ice crystal
+!--    concentration
        IF ( microphysics_ice_phase )  THEN
 
@@ -1773,8 +1726,8 @@
              IF ( timestep_scheme(1:5) == 'runge' )  THEN
                 IF ( ws_scheme_sca )  THEN
-                   CALL advec_s_ws( advc_flags_s, qi, 'qi',                    &
-                                    bc_dirichlet_l  .OR.  bc_radiation_l,      &
-                                    bc_dirichlet_n  .OR.  bc_radiation_n,      &
-                                    bc_dirichlet_r  .OR.  bc_radiation_r,      &
+                   CALL advec_s_ws( advc_flags_s, qi, 'qi',                                        &
+                                    bc_dirichlet_l  .OR.  bc_radiation_l,                          &
+                                    bc_dirichlet_n  .OR.  bc_radiation_n,                          &
+                                    bc_dirichlet_r  .OR.  bc_radiation_r,                          &
                                     bc_dirichlet_s  .OR.  bc_radiation_s )
                 ELSE
@@ -1786,13 +1739,13 @@
           ENDIF
 
-          CALL diffusion_s( qi,                                                &
-                            surf_def_h(0)%qisws, surf_def_h(1)%qisws,          &
-                            surf_def_h(2)%qisws,                               &
-                            surf_lsm_h%qisws,    surf_usm_h%qisws,             &
-                            surf_def_v(0)%qisws, surf_def_v(1)%qisws,          &
-                            surf_def_v(2)%qisws, surf_def_v(3)%qisws,          &
-                            surf_lsm_v(0)%qisws, surf_lsm_v(1)%qisws,          &
-                            surf_lsm_v(2)%qisws, surf_lsm_v(3)%qisws,          &
-                            surf_usm_v(0)%qisws, surf_usm_v(1)%qisws,          &
+          CALL diffusion_s( qi,                                                                    &
+                            surf_def_h(0)%qisws, surf_def_h(1)%qisws,                              &
+                            surf_def_h(2)%qisws,                                                   &
+                            surf_lsm_h%qisws,    surf_usm_h%qisws,                                 &
+                            surf_def_v(0)%qisws, surf_def_v(1)%qisws,                              &
+                            surf_def_v(2)%qisws, surf_def_v(3)%qisws,                              &
+                            surf_lsm_v(0)%qisws, surf_lsm_v(1)%qisws,                              &
+                            surf_lsm_v(2)%qisws, surf_lsm_v(3)%qisws,                              &
+                            surf_usm_v(0)%qisws, surf_usm_v(1)%qisws,                              &
                             surf_usm_v(2)%qisws, surf_usm_v(3)%qisws )
 
@@ -1804,11 +1757,10 @@
                 !DIR$ IVDEP
                 DO  k = nzb+1, nzt
-                   qi_p(k,j,i) = qi(k,j,i) + ( dt_3d * ( sbt * tend(k,j,i) +   &
-                                                      tsc(3) * tqi_m(k,j,i) )  &
-                                                    - tsc(5) * rdf_sc(k) *     &
-                                                               qi(k,j,i)       &
-                                             )                                 &
-                                    * MERGE( 1.0_wp, 0.0_wp,                   &
-                                             BTEST( wall_flags_total_0(k,j,i), 0 )   &
+                   qi_p(k,j,i) = qi(k,j,i) + ( dt_3d * ( sbt * tend(k,j,i) +                       &
+                                                      tsc(3) * tqi_m(k,j,i) )                      &
+                                                    - tsc(5) * rdf_sc(k) *                         &
+                                                               qi(k,j,i)                           &
+                                             )                                                     &
+                                    * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) &
                                           )
                    IF ( qi_p(k,j,i) < 0.0_wp )  qi_p(k,j,i) = 0.0_wp
@@ -1833,6 +1785,5 @@
                    DO  j = nys, nyn
                       DO  k = nzb+1, nzt
-                         tqi_m(k,j,i) =   -9.5625_wp * tend(k,j,i)             &
-                                         + 5.3125_wp * tqi_m(k,j,i)
+                         tqi_m(k,j,i) =   -9.5625_wp * tend(k,j,i) + 5.3125_wp * tqi_m(k,j,i)
                       ENDDO
                    ENDDO
@@ -1865,8 +1816,8 @@
              IF ( timestep_scheme(1:5) == 'runge' )  THEN
                 IF ( ws_scheme_sca )  THEN
-                   CALL advec_s_ws( advc_flags_s, ni, 'ni',                    &
-                                    bc_dirichlet_l  .OR.  bc_radiation_l,      &
-                                    bc_dirichlet_n  .OR.  bc_radiation_n,      &
-                                    bc_dirichlet_r  .OR.  bc_radiation_r,      &
+                   CALL advec_s_ws( advc_flags_s, ni, 'ni',                                        &
+                                    bc_dirichlet_l  .OR.  bc_radiation_l,                          &
+                                    bc_dirichlet_n  .OR.  bc_radiation_n,                          &
+                                    bc_dirichlet_r  .OR.  bc_radiation_r,                          &
                                     bc_dirichlet_s  .OR.  bc_radiation_s )
                 ELSE
@@ -1878,13 +1829,13 @@
           ENDIF
 
-          CALL diffusion_s( ni,                                                &
-                            surf_def_h(0)%nisws, surf_def_h(1)%nisws,          &
-                            surf_def_h(2)%nisws,                               &
-                            surf_lsm_h%nisws,    surf_usm_h%nisws,             &
-                            surf_def_v(0)%nisws, surf_def_v(1)%nisws,          &
-                            surf_def_v(2)%nisws, surf_def_v(3)%nisws,          &
-                            surf_lsm_v(0)%nisws, surf_lsm_v(1)%nisws,          &
-                            surf_lsm_v(2)%nisws, surf_lsm_v(3)%nisws,          &
-                            surf_usm_v(0)%nisws, surf_usm_v(1)%nisws,          &
+          CALL diffusion_s( ni,                                                                    &
+                            surf_def_h(0)%nisws, surf_def_h(1)%nisws,                              &
+                            surf_def_h(2)%nisws,                                                   &
+                            surf_lsm_h%nisws,    surf_usm_h%nisws,                                 &
+                            surf_def_v(0)%nisws, surf_def_v(1)%nisws,                              &
+                            surf_def_v(2)%nisws, surf_def_v(3)%nisws,                              &
+                            surf_lsm_v(0)%nisws, surf_lsm_v(1)%nisws,                              &
+                            surf_lsm_v(2)%nisws, surf_lsm_v(3)%nisws,                              &
+                            surf_usm_v(0)%nisws, surf_usm_v(1)%nisws,                              &
                             surf_usm_v(2)%nisws, surf_usm_v(3)%nisws )
 
@@ -1896,11 +1847,10 @@
                 !DIR$ IVDEP
                 DO  k = nzb+1, nzt
-                   ni_p(k,j,i) = ni(k,j,i) + ( dt_3d * ( sbt * tend(k,j,i) +   &
-                                                      tsc(3) * tni_m(k,j,i) )  &
-                                                    - tsc(5) * rdf_sc(k) *     &
-                                                               ni(k,j,i)       &
-                                             )                                 &
-                                   * MERGE( 1.0_wp, 0.0_wp,                    &
-                                             BTEST( wall_flags_total_0(k,j,i), 0 )   &
+                   ni_p(k,j,i) = ni(k,j,i) + ( dt_3d * ( sbt * tend(k,j,i) +                       &
+                                                      tsc(3) * tni_m(k,j,i) )                      &
+                                                    - tsc(5) * rdf_sc(k) *                         &
+                                                               ni(k,j,i)                           &
+                                             )                                                     &
+                                   * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 )  &
                                           )
                    IF ( ni_p(k,j,i) < 0.0_wp )  ni_p(k,j,i) = 0.0_wp
@@ -1925,6 +1875,5 @@
                    DO  j = nys, nyn
                       DO  k = nzb+1, nzt
-                         tni_m(k,j,i) =  -9.5625_wp * tend(k,j,i)             &
-                                         + 5.3125_wp * tni_m(k,j,i)
+                         tni_m(k,j,i) =  -9.5625_wp * tend(k,j,i) + 5.3125_wp * tni_m(k,j,i)
                       ENDDO
                    ENDDO
@@ -1938,6 +1887,6 @@
 
 !
-!--    If required, calculate prognostic equations for rain water content
-!--    and rain drop concentration
+!--    If required, calculate prognostic equations for rain water content and rain drop
+!--    concentration.
        IF ( microphysics_seifert )  THEN
 
@@ -1965,8 +1914,8 @@
              IF ( timestep_scheme(1:5) == 'runge' )  THEN
                 IF ( ws_scheme_sca )  THEN
-                   CALL advec_s_ws( advc_flags_s, qr, 'qr',                    &
-                                    bc_dirichlet_l  .OR.  bc_radiation_l,      &
-                                    bc_dirichlet_n  .OR.  bc_radiation_n,      &
-                                    bc_dirichlet_r  .OR.  bc_radiation_r,      &
+                   CALL advec_s_ws( advc_flags_s, qr, 'qr',                                        &
+                                    bc_dirichlet_l  .OR.  bc_radiation_l,                          &
+                                    bc_dirichlet_n  .OR.  bc_radiation_n,                          &
+                                    bc_dirichlet_r  .OR.  bc_radiation_r,                          &
                                     bc_dirichlet_s  .OR.  bc_radiation_s )
                 ELSE
@@ -1978,13 +1927,13 @@
           ENDIF
 
-          CALL diffusion_s( qr,                                                &
-                            surf_def_h(0)%qrsws, surf_def_h(1)%qrsws,          &
-                            surf_def_h(2)%qrsws,                               &
-                            surf_lsm_h%qrsws,    surf_usm_h%qrsws,             &
-                            surf_def_v(0)%qrsws, surf_def_v(1)%qrsws,          &
-                            surf_def_v(2)%qrsws, surf_def_v(3)%qrsws,          &
-                            surf_lsm_v(0)%qrsws, surf_lsm_v(1)%qrsws,          &
-                            surf_lsm_v(2)%qrsws, surf_lsm_v(3)%qrsws,          &
-                            surf_usm_v(0)%qrsws, surf_usm_v(1)%qrsws,          &
+          CALL diffusion_s( qr,                                                                    &
+                            surf_def_h(0)%qrsws, surf_def_h(1)%qrsws,                              &
+                            surf_def_h(2)%qrsws,                                                   &
+                            surf_lsm_h%qrsws,    surf_usm_h%qrsws,                                 &
+                            surf_def_v(0)%qrsws, surf_def_v(1)%qrsws,                              &
+                            surf_def_v(2)%qrsws, surf_def_v(3)%qrsws,                              &
+                            surf_lsm_v(0)%qrsws, surf_lsm_v(1)%qrsws,                              &
+                            surf_lsm_v(2)%qrsws, surf_lsm_v(3)%qrsws,                              &
+                            surf_usm_v(0)%qrsws, surf_usm_v(1)%qrsws,                              &
                             surf_usm_v(2)%qrsws, surf_usm_v(3)%qrsws )
 
@@ -1996,11 +1945,10 @@
                 !DIR$ IVDEP
                 DO  k = nzb+1, nzt
-                   qr_p(k,j,i) = qr(k,j,i) + ( dt_3d * ( sbt * tend(k,j,i) +   &
-                                                      tsc(3) * tqr_m(k,j,i) )  &
-                                                    - tsc(5) * rdf_sc(k) *     &
-                                                               qr(k,j,i)       &
-                                             )                                 &
-                                    * MERGE( 1.0_wp, 0.0_wp,                   &
-                                             BTEST( wall_flags_total_0(k,j,i), 0 )   &
+                   qr_p(k,j,i) = qr(k,j,i) + ( dt_3d * ( sbt * tend(k,j,i) +                       &
+                                                      tsc(3) * tqr_m(k,j,i) )                      &
+                                                    - tsc(5) * rdf_sc(k) *                         &
+                                                               qr(k,j,i)                           &
+                                             )                                                     &
+                                    * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) &
                                           )
                    IF ( qr_p(k,j,i) < 0.0_wp )  qr_p(k,j,i) = 0.0_wp
@@ -2025,6 +1973,5 @@
                    DO  j = nys, nyn
                       DO  k = nzb+1, nzt
-                         tqr_m(k,j,i) =   -9.5625_wp * tend(k,j,i)             &
-                                         + 5.3125_wp * tqr_m(k,j,i)
+                         tqr_m(k,j,i) =   -9.5625_wp * tend(k,j,i) + 5.3125_wp * tqr_m(k,j,i)
                       ENDDO
                    ENDDO
@@ -2057,8 +2004,8 @@
              IF ( timestep_scheme(1:5) == 'runge' )  THEN
                 IF ( ws_scheme_sca )  THEN
-                   CALL advec_s_ws( advc_flags_s, nr, 'nr',                    &
-                                    bc_dirichlet_l  .OR.  bc_radiation_l,      &
-                                    bc_dirichlet_n  .OR.  bc_radiation_n,      &
-                                    bc_dirichlet_r  .OR.  bc_radiation_r,      &
+                   CALL advec_s_ws( advc_flags_s, nr, 'nr',                                        &
+                                    bc_dirichlet_l  .OR.  bc_radiation_l,                          &
+                                    bc_dirichlet_n  .OR.  bc_radiation_n,                          &
+                                    bc_dirichlet_r  .OR.  bc_radiation_r,                          &
                                     bc_dirichlet_s  .OR.  bc_radiation_s )
                 ELSE
@@ -2070,13 +2017,13 @@
           ENDIF
 
-          CALL diffusion_s( nr,                                                &
-                            surf_def_h(0)%nrsws, surf_def_h(1)%nrsws,          &
-                            surf_def_h(2)%nrsws,                               &
-                            surf_lsm_h%nrsws,    surf_usm_h%nrsws,             &
-                            surf_def_v(0)%nrsws, surf_def_v(1)%nrsws,          &
-                            surf_def_v(2)%nrsws, surf_def_v(3)%nrsws,          &
-                            surf_lsm_v(0)%nrsws, surf_lsm_v(1)%nrsws,          &
-                            surf_lsm_v(2)%nrsws, surf_lsm_v(3)%nrsws,          &
-                            surf_usm_v(0)%nrsws, surf_usm_v(1)%nrsws,          &
+          CALL diffusion_s( nr,                                                                    &
+                            surf_def_h(0)%nrsws, surf_def_h(1)%nrsws,                              &
+                            surf_def_h(2)%nrsws,                                                   &
+                            surf_lsm_h%nrsws,    surf_usm_h%nrsws,                                 &
+                            surf_def_v(0)%nrsws, surf_def_v(1)%nrsws,                              &
+                            surf_def_v(2)%nrsws, surf_def_v(3)%nrsws,                              &
+                            surf_lsm_v(0)%nrsws, surf_lsm_v(1)%nrsws,                              &
+                            surf_lsm_v(2)%nrsws, surf_lsm_v(3)%nrsws,                              &
+                            surf_usm_v(0)%nrsws, surf_usm_v(1)%nrsws,                              &
                             surf_usm_v(2)%nrsws, surf_usm_v(3)%nrsws )
 
@@ -2088,11 +2035,10 @@
                 !DIR$ IVDEP
                 DO  k = nzb+1, nzt
-                   nr_p(k,j,i) = nr(k,j,i) + ( dt_3d * ( sbt * tend(k,j,i) +   &
-                                                      tsc(3) * tnr_m(k,j,i) )  &
-                                                    - tsc(5) * rdf_sc(k) *     &
-                                                               nr(k,j,i)       &
-                                             )                                 &
-                                   * MERGE( 1.0_wp, 0.0_wp,                    &
-                                             BTEST( wall_flags_total_0(k,j,i), 0 )   &
+                   nr_p(k,j,i) = nr(k,j,i) + ( dt_3d * ( sbt * tend(k,j,i) +                       &
+                                                      tsc(3) * tnr_m(k,j,i) )                      &
+                                                    - tsc(5) * rdf_sc(k) *                         &
+                                                               nr(k,j,i)                           &
+                                             )                                                     &
+                                   * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 )  &
                                           )
                    IF ( nr_p(k,j,i) < 0.0_wp )  nr_p(k,j,i) = 0.0_wp
@@ -2132,21 +2078,22 @@
 
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Control of microphysics for grid points i,j
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
     SUBROUTINE bcm_prognostic_equations_ij( i, j, i_omp_start, tn )
 
 
        INTEGER(iwp), INTENT(IN) ::  i            !< grid index in x-direction
+       INTEGER(iwp), INTENT(IN) ::  i_omp_start  !< first loop index of i-loop in
+                                                 !< prognostic_equations
        INTEGER(iwp), INTENT(IN) ::  j            !< grid index in y-direction
        INTEGER(iwp)             ::  k            !< grid index in z-direction
-       INTEGER(iwp), INTENT(IN) ::  i_omp_start  !< first loop index of i-loop in prognostic_equations
        INTEGER(iwp), INTENT(IN) ::  tn           !< task number of openmp task
 
 !
-!--    If required, calculate prognostic equations for cloud water content
-!--    and cloud drop concentration
+!--    If required, calculate prognostic equations for cloud water content and cloud drop
+!--    concentration.
        IF ( microphysics_morrison )  THEN
 !
@@ -2156,10 +2103,10 @@
           THEN
              IF ( ws_scheme_sca )  THEN
-                CALL advec_s_ws( advc_flags_s, i, j, qc, 'qc', flux_s_qc,      &
-                                 diss_s_qc, flux_l_qc, diss_l_qc,              &
-                                 i_omp_start, tn,                              &
-                                 bc_dirichlet_l  .OR.  bc_radiation_l,         &
-                                 bc_dirichlet_n  .OR.  bc_radiation_n,         &
-                                 bc_dirichlet_r  .OR.  bc_radiation_r,         &
+                CALL advec_s_ws( advc_flags_s, i, j, qc, 'qc', flux_s_qc,                          &
+                                 diss_s_qc, flux_l_qc, diss_l_qc,                                  &
+                                 i_omp_start, tn,                                                  &
+                                 bc_dirichlet_l  .OR.  bc_radiation_l,                             &
+                                 bc_dirichlet_n  .OR.  bc_radiation_n,                             &
+                                 bc_dirichlet_r  .OR.  bc_radiation_r,                             &
                                  bc_dirichlet_s  .OR.  bc_radiation_s )
              ELSE
@@ -2169,13 +2116,13 @@
              CALL advec_s_up( i, j, qc )
           ENDIF
-          CALL diffusion_s( i, j, qc,                                   &
-                            surf_def_h(0)%qcsws, surf_def_h(1)%qcsws,   &
-                            surf_def_h(2)%qcsws,                        &
-                            surf_lsm_h%qcsws,    surf_usm_h%qcsws,      &
-                            surf_def_v(0)%qcsws, surf_def_v(1)%qcsws,   &
-                            surf_def_v(2)%qcsws, surf_def_v(3)%qcsws,   &
-                            surf_lsm_v(0)%qcsws, surf_lsm_v(1)%qcsws,   &
-                            surf_lsm_v(2)%qcsws, surf_lsm_v(3)%qcsws,   &
-                            surf_usm_v(0)%qcsws, surf_usm_v(1)%qcsws,   &
+          CALL diffusion_s( i, j, qc,                                                              &
+                            surf_def_h(0)%qcsws, surf_def_h(1)%qcsws,                              &
+                            surf_def_h(2)%qcsws,                                                   &
+                            surf_lsm_h%qcsws,    surf_usm_h%qcsws,                                 &
+                            surf_def_v(0)%qcsws, surf_def_v(1)%qcsws,                              &
+                            surf_def_v(2)%qcsws, surf_def_v(3)%qcsws,                              &
+                            surf_lsm_v(0)%qcsws, surf_lsm_v(1)%qcsws,                              &
+                            surf_lsm_v(2)%qcsws, surf_lsm_v(3)%qcsws,                              &
+                            surf_usm_v(0)%qcsws, surf_usm_v(1)%qcsws,                              &
                             surf_usm_v(2)%qcsws, surf_usm_v(3)%qcsws )
 
@@ -2183,12 +2130,11 @@
 !--       Prognostic equation for cloud water content
           DO  k = nzb+1, nzt
-             qc_p(k,j,i) = qc(k,j,i) + ( dt_3d *                         &
-                                                ( tsc(2) * tend(k,j,i) + &
-                                                  tsc(3) * tqc_m(k,j,i) )&
-                                                - tsc(5) * rdf_sc(k)     &
-                                                         * qc(k,j,i)     &
-                                       )                                 &
-                                 * MERGE( 1.0_wp, 0.0_wp,                &
-                                          BTEST( wall_flags_total_0(k,j,i), 0 )&
+             qc_p(k,j,i) = qc(k,j,i) + ( dt_3d *                                                   &
+                                                ( tsc(2) * tend(k,j,i) +                           &
+                                                  tsc(3) * tqc_m(k,j,i) )                          &
+                                                - tsc(5) * rdf_sc(k)                               &
+                                                         * qc(k,j,i)                               &
+                                       )                                                           &
+                                 * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 )    &
                                         )
              IF ( qc_p(k,j,i) < 0.0_wp )  qc_p(k,j,i) = 0.0_wp
@@ -2204,6 +2150,5 @@
                       intermediate_timestep_count_max )  THEN
                 DO  k = nzb+1, nzt
-                   tqc_m(k,j,i) =   -9.5625_wp * tend(k,j,i) +           &
-                                     5.3125_wp * tqc_m(k,j,i)
+                   tqc_m(k,j,i) =   -9.5625_wp * tend(k,j,i) + 5.3125_wp * tqc_m(k,j,i)
                 ENDDO
              ENDIF
@@ -2215,10 +2160,10 @@
           IF ( timestep_scheme(1:5) == 'runge' )  THEN
              IF ( ws_scheme_sca )  THEN
-                CALL advec_s_ws( advc_flags_s, i, j, nc, 'nc', flux_s_nc,      &
-                                 diss_s_nc, flux_l_nc, diss_l_nc,              &
-                                 i_omp_start, tn,                              &
-                                 bc_dirichlet_l  .OR.  bc_radiation_l,         &
-                                 bc_dirichlet_n  .OR.  bc_radiation_n,         &
-                                 bc_dirichlet_r  .OR.  bc_radiation_r,         &
+                CALL advec_s_ws( advc_flags_s, i, j, nc, 'nc', flux_s_nc,                          &
+                                 diss_s_nc, flux_l_nc, diss_l_nc,                                  &
+                                 i_omp_start, tn,                                                  &
+                                 bc_dirichlet_l  .OR.  bc_radiation_l,                             &
+                                 bc_dirichlet_n  .OR.  bc_radiation_n,                             &
+                                 bc_dirichlet_r  .OR.  bc_radiation_r,                             &
                                  bc_dirichlet_s  .OR.  bc_radiation_s )
              ELSE
@@ -2228,13 +2173,13 @@
              CALL advec_s_up( i, j, nc )
           ENDIF
-          CALL diffusion_s( i, j, nc,                                    &
-                            surf_def_h(0)%ncsws, surf_def_h(1)%ncsws,    &
-                            surf_def_h(2)%ncsws,                         &
-                            surf_lsm_h%ncsws,    surf_usm_h%ncsws,       &
-                            surf_def_v(0)%ncsws, surf_def_v(1)%ncsws,    &
-                            surf_def_v(2)%ncsws, surf_def_v(3)%ncsws,    &
-                            surf_lsm_v(0)%ncsws, surf_lsm_v(1)%ncsws,    &
-                            surf_lsm_v(2)%ncsws, surf_lsm_v(3)%ncsws,    &
-                            surf_usm_v(0)%ncsws, surf_usm_v(1)%ncsws,    &
+          CALL diffusion_s( i, j, nc,                                                              &
+                            surf_def_h(0)%ncsws, surf_def_h(1)%ncsws,                              &
+                            surf_def_h(2)%ncsws,                                                   &
+                            surf_lsm_h%ncsws,    surf_usm_h%ncsws,                                 &
+                            surf_def_v(0)%ncsws, surf_def_v(1)%ncsws,                              &
+                            surf_def_v(2)%ncsws, surf_def_v(3)%ncsws,                              &
+                            surf_lsm_v(0)%ncsws, surf_lsm_v(1)%ncsws,                              &
+                            surf_lsm_v(2)%ncsws, surf_lsm_v(3)%ncsws,                              &
+                            surf_usm_v(0)%ncsws, surf_usm_v(1)%ncsws,                              &
                             surf_usm_v(2)%ncsws, surf_usm_v(3)%ncsws )
 
@@ -2242,12 +2187,11 @@
 !--       Prognostic equation for cloud drop concentration
           DO  k = nzb+1, nzt
-             nc_p(k,j,i) = nc(k,j,i) + ( dt_3d *                         &
-                                                ( tsc(2) * tend(k,j,i) + &
-                                                  tsc(3) * tnc_m(k,j,i) )&
-                                                - tsc(5) * rdf_sc(k)     &
-                                                         * nc(k,j,i)     &
-                                       )                                 &
-                                 * MERGE( 1.0_wp, 0.0_wp,                &
-                                          BTEST( wall_flags_total_0(k,j,i), 0 )&
+             nc_p(k,j,i) = nc(k,j,i) + ( dt_3d *                                                   &
+                                                ( tsc(2) * tend(k,j,i) +                           &
+                                                  tsc(3) * tnc_m(k,j,i) )                          &
+                                                - tsc(5) * rdf_sc(k)                               &
+                                                         * nc(k,j,i)                               &
+                                       )                                                           &
+                                 * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 )    &
                                         )
              IF ( nc_p(k,j,i) < 0.0_wp )  nc_p(k,j,i) = 0.0_wp
@@ -2263,6 +2207,5 @@
                       intermediate_timestep_count_max )  THEN
                 DO  k = nzb+1, nzt
-                   tnc_m(k,j,i) =   -9.5625_wp * tend(k,j,i) +           &
-                                     5.3125_wp * tnc_m(k,j,i)
+                   tnc_m(k,j,i) =   -9.5625_wp * tend(k,j,i) + 5.3125_wp * tnc_m(k,j,i)
                 ENDDO
              ENDIF
